// ChatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "hostilechat.h"
#include "ChatDlg.h"
#include "Preferences.h"
#include "Sound.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const UINT IDT_CHECK_PRESENTS_USERS = 0xf0;
/////////////////////////////////////////////////////////////////////////////
// CChatDlg dialog


CChatDlg::CChatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChatDlg::IDD, pParent), m_btnProperties(IDB_PROPERTIES, 
	IDB_PROPERTIES_MASK, CSize(31,31)), m_btnRefresh(IDB_REFRESH, 
	IDB_REFRESH_MASK, CSize(30,30)),
	m_btnSend(IDB_SEND, IDB_SEND_MASK, CSize(31,24)),
	m_btnClose(IDB_CLOSE, IDB_CLOSE_MASK, CSize(33,33))
{
	//{{AFX_DATA_INIT(CChatDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_CHAT);
	m_bEnableScrolling = true;
}


void CChatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatDlg)
	DDX_Control(pDX, IDC_EDIT1, m_ebMessage);
	DDX_Control(pDX, IDCANCEL, m_btnClose);
	DDX_Control(pDX, IDC_SEND, m_btnSend);
	DDX_Control(pDX, IDC_REFRESH, m_btnRefresh);
	DDX_Control(pDX, IDC_PROPERTIES, m_btnProperties);
	DDX_Control(pDX, IDC_LIST1, m_chatList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChatDlg, CDialog)
	//{{AFX_MSG_MAP(CChatDlg)
	ON_BN_CLICKED(IDC_PROPERTIES, OnProperties)
	ON_WM_KEYDOWN()
	ON_BN_CLICKED(IDC_SEND_2, OnSend2)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_WM_CLOSE()
	ON_MESSAGE(WM_RECIEVE_MESSAGE, OnRecieveMessage)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_WM_TIMER()
	ON_MESSAGE(WM_USER_IN_CHAT, OnUserInChat)
	ON_WM_ACTIVATE()
	ON_WM_SHOWWINDOW()
	ON_WM_SETCURSOR()
	ON_WM_WINDOWPOSCHANGED()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatDlg message handlers

BOOL CChatDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, FALSE);

	CHostileChatApp *pApp = (CHostileChatApp*) AfxGetApp();

	CUser user; pApp->GetCurrentUser(user);
//	m_listUsers.AddString(user.name);
	
//	CFont font;
//	font.CreateFont(14, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
//		0, 0, DEFAULT_QUALITY, FF_DONTCARE, "Arial Cyr");

//	m_listUsers.SetFaceFont(RGB(60,100,100), font);
	//        
	PreferencesChat prefMList;
	pApp->GetPreferences(&prefMList);

	m_chatList.SetFromProperties(prefMList.rgbTitle, prefMList.fontTitle);
	m_chatList.SetWhatProperties(prefMList.rgbText, prefMList.fontText);
	m_chatList.SetBkColor(prefMList.rgbBackground);

//	SetTimer(IDT_CHECK_PRESENTS_USERS, 1000, NULL);
//	UpdateData(false);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CChatDlg::OnProperties() 
{
	CPreferences dlg(RUNTIME_CLASS(PreferencesChat));

	if(dlg.DoModal() == IDOK) {
		//        
		PreferencesChat prefMList;
		((CHostileChatApp*) AfxGetApp())->GetPreferences(&prefMList);

		m_chatList.SetFromProperties(prefMList.rgbTitle, prefMList.fontTitle);
		m_chatList.SetWhatProperties(prefMList.rgbText, prefMList.fontText);
		m_chatList.SetBkColor(prefMList.rgbBackground);
		
		m_chatList.RedrawWindow();
		UpdateData(false);
	}
}

void CChatDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	AfxMessageBox( CString(nChar));
	
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CChatDlg::OnSend2() 
{
	OnSend();
}

void CChatDlg::OnSend() 
{

	CString szMessage = "/x0";
	m_ebMessage.GetWindowText(szMessage);
	if( szMessage == "" ) return;

	CUser user;
	CHostileChatApp *pApp = (CHostileChatApp *) AfxGetApp();

	pApp->GetCurrentUser(user);

	CMessage message; strcpy(message.creator, user.name);
	strcpy(message.contents, szMessage);
	message.id = CMessage::MID_CHAT;

	pApp->m_pMainWnd->SendMessage(WM_BROADCAST, (DWORD) &message, TYPE_MESSAGE);
	m_ebMessage.SetSel(0, m_ebMessage.LineLength(), false);	
}

void CChatDlg::OnRecieveMessage(WPARAM wParm, LPARAM lParm)
{
	CMessage *message = (CMessage  *) wParm;
	CString name = message->creator, contents = message->contents;
	
	m_chatList.AddString(name + "%" + message->contents);

	if(m_bEnableScrolling)
		m_chatList.SetTopIndex(m_chatList.GetCount() - 1);

	CSound::PlayResource(ID_SOUND_SEND);

	UpdateData(false);

	delete message;
}

void CChatDlg::OnClose() 
{
//	CDialog::OnClose();
	ShowWindow(SW_HIDE);
}

void CChatDlg::OnCancel() 
{
	OnClose();
}

BOOL CChatDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if( wParam == WM_DESTROY) {
		OnClose();
		return true;
	}
	else
		return CDialog::OnCommand(wParam, lParam);
}

void CChatDlg::OnRefresh() 
{
	if (m_chatList.GetCount() == 0) return;

	CString szlastmessage = "/x0";
	m_chatList.GetText(m_chatList.GetCount() - 1, szlastmessage);
	m_chatList.ResetContent();
	m_chatList.AddString(szlastmessage);
	m_ebMessage.SetSel(0, m_ebMessage.LineLength(), false);	

}

void CChatDlg::OnChangeEdit1() 
{
	CSound::PlayResource(ID_SOUND_TYPE);
}

void CChatDlg::OnTimer(UINT nIDEvent) 
{
	switch(nIDEvent) 
	{
	case IDT_CHECK_PRESENTS_USERS:
		{
			CHostileChatApp *pApp = (CHostileChatApp *) AfxGetApp();
			CUser user; CMessage message;

			pApp->GetCurrentUser(user);
			message.id = CMessage::MID_IN_CHATROOM;
			strcpy(message.creator,user.name);
			strcpy(message.contents, "none");

			pApp->m_pMainWnd->SendMessage(WM_BROADCAST, (DWORD) &message, TYPE_MESSAGE);

			//     
/*			for( int i = 0; i < m_listUsers.GetCount(); i++ ) 
			{
				DWORD data = m_listUsers.GetItemData(i); 

				if( data < 1 ) {
					m_listUsers.DeleteString(i);
//					i--;
				}
				else {
					data--;
					m_listUsers.SetItemData(i, data);
				}
			} */
		}
		break;
	}

	CDialog::OnTimer(nIDEvent);
}

void CChatDlg::OnUserInChat(WPARAM wParam, LPARAM lParam)
{
	if( wParam == 0 ) return;

	CMessage *message = (CMessage *) wParam;
//	CUser user; int result;

//	CHostileChatApp *pApp = (CHostileChatApp *) AfxGetApp();
//	pApp->GetCurrentUser(user);

	//,     
/*	if((result = m_listUsers.FindString(0, message->creator)) == LB_ERR ) {
	//    
		result = m_listUsers.AddString(message->creator);
	}
	m_listUsers.SetItemData(result, 2);
*/
}

void CChatDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);
}

void CChatDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	if( !bShow ) {
		KillTimer(IDT_CHECK_PRESENTS_USERS);
	}
	else {
		SetTimer(IDT_CHECK_PRESENTS_USERS, 1000, NULL);
	}
}

BOOL CChatDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if(nHitTest == HTVSCROLL) {
		m_bEnableScrolling = false;
	}
	else m_bEnableScrolling = true;
	
	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

void CChatDlg::OnWindowPosChanged(WINDOWPOS FAR* lpwndpos) 
{
	CDialog::OnWindowPosChanged(lpwndpos);
	
	HDWP	hdwp;

	hdwp = BeginDeferWindowPos(6);
	if(hdwp == NULL) return;

	DeferWindowPos(hdwp, m_btnClose.GetSafeHwnd(), NULL, 
		lpwndpos->cx - 40, 
		lpwndpos->cy - 58,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	DeferWindowPos(hdwp, m_btnSend.GetSafeHwnd(), NULL, 
		lpwndpos->cx - 79, 
		lpwndpos->cy - 56,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	DeferWindowPos(hdwp, m_btnProperties.GetSafeHwnd(), NULL, 
		3, 
		lpwndpos->cy - 60,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	DeferWindowPos(hdwp, m_chatList.GetSafeHwnd(), NULL, 1, 5,
		lpwndpos->cx - 8,
		lpwndpos->cy - 63,
		SWP_NOZORDER | SWP_NOMOVE );

	DeferWindowPos(hdwp, m_ebMessage.GetSafeHwnd(), NULL, 70,
		lpwndpos->cy - 52,
		lpwndpos->cx - 153, 
		20,
		SWP_NOZORDER );

	DeferWindowPos(hdwp, m_btnRefresh.GetSafeHwnd(), NULL, 
		35,
		lpwndpos->cy - 58,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	EndDeferWindowPos(hdwp);	
}
