// ChatMessageList.cpp : implementation file
//

#include "stdafx.h"
#include "hostilechat.h"
#include "ChatMessageList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChatMessageList

CChatMessageList::CChatMessageList()
{
	//m_bkColor = GetSysColor(COLOR_BTNFACE);
	m_bkColor = RGB(0, 0, 0);
	//m_brushFace.CreateSolidBrush(m_bkColor);
	m_rgbFrom = RGB(255,255,255);
	m_rgbWhat = RGB(255,255,255);

	m_bFixedHeight = false;
}

CChatMessageList::~CChatMessageList()
{
}


BEGIN_MESSAGE_MAP(CChatMessageList, CListBox)
	//{{AFX_MSG_MAP(CChatMessageList)
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatMessageList message handlers

void CChatMessageList::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	if( long(lpDrawItemStruct->itemID) < 0 ) return;

	CDC* pDC = CDC::FromHandle( lpDrawItemStruct->hDC );

	pDC->SetBkColor(m_bkColor);
//	COLORREF header = RGB(0,255,50);
//	COLORREF text = RGB(234,234,234);
	
	if( ((lpDrawItemStruct->itemState & ODS_SELECTED) == ODS_SELECTED) &&
		((lpDrawItemStruct->itemState & ODS_FOCUS) == ODS_FOCUS)) 
	{
		pDC->SetTextColor(RGB(50,50,255));
	}
	else
		pDC->SetTextColor(m_rgbFrom);

	CString title;
	GetText(lpDrawItemStruct->itemID, title);

	//,    ODA_DRAWENTIRE
	RECT rect = lpDrawItemStruct->rcItem;
//	CFont title_font;

//	CString name(TCHAR(' '), (title.Left(title.Find('%'))).GetLength());
	
//	title_font.CreateFont(16, 0, 0, 0, FW_BOLD, 0, 0, 0, DEFAULT_CHARSET,
//		0, 0, DEFAULT_QUALITY, FF_DONTCARE, "Arial Cyr");

//	CFont*	pOldFont = pDC->SelectObject(&title_font);
	CFont*	pOldFont = pDC->SelectObject(&m_fontFrom);

	CString name = title.Left(title.Find('%'));
	int offset = pDC->TextOut( lpDrawItemStruct->rcItem.left,
		lpDrawItemStruct->rcItem.top, name);

	pDC->DrawText( name, &rect, DT_CALCRECT | DT_WORDBREAK | DT_LEFT);

	pDC->SelectObject(&m_fontWhat);

	RECT aRect = lpDrawItemStruct->rcItem;
	pDC->DrawText( title.Right(title.GetLength() - title.Find('%') - 1),
		&aRect, DT_CALCRECT | DT_WORDBREAK | DT_LEFT);

	lpDrawItemStruct->rcItem.top += 1;
	lpDrawItemStruct->rcItem.left += rect.right + 10;

	pDC->SetTextColor(m_rgbWhat);
	pDC->DrawText( title.Right(title.GetLength() - title.Find('%') - 1),
		&lpDrawItemStruct->rcItem, DT_WORDBREAK);

	pDC->SelectObject(pOldFont);
}

void CChatMessageList::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	CDC* pDC = GetDC();
	RECT rect;

	if( long(lpMeasureItemStruct->itemID) < 0 ) return;

	if( m_bFixedHeight ) {
		lpMeasureItemStruct->itemHeight = m_iFixedHeight;
	}
	else {
		GetClientRect(&rect);
		CString title;
	
		GetText(lpMeasureItemStruct->itemID, title);

		lpMeasureItemStruct->itemHeight = pDC->
			DrawText( title, &rect, DT_CALCRECT | DT_WORDBREAK | DT_LEFT);
		lpMeasureItemStruct->itemHeight += 5;
	}
}

HBRUSH CChatMessageList::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	return m_brushFace;
}

void CChatMessageList::SetBkColor(COLORREF rgb)
{
	m_bkColor = rgb;
	m_brushFace.DeleteObject();
	m_brushFace.CreateSolidBrush(rgb);
}

void CChatMessageList::SetFromProperties(COLORREF rgb, CFont & font)
{
	m_rgbFrom = rgb;

	LOGFONT logfont;

	font.GetLogFont(&logfont);
	m_fontFrom.DeleteObject();
	m_fontFrom.CreateFontIndirect(&logfont);
}

void CChatMessageList::SetWhatProperties(COLORREF rgb, CFont & font)
{
	m_rgbWhat = rgb;

	LOGFONT logfont;

	font.GetLogFont(&logfont);
	m_fontWhat.DeleteObject();
	m_fontWhat.CreateFontIndirect(&logfont);
}

void CChatMessageList::SetItemHeight(int height)
{
	m_bFixedHeight = true;
	m_iFixedHeight = height;
}

void CChatMessageList::PreSubclassWindow() 
{
	CDC *pDC = GetDC();
	
//	LOGFONT logfont;

//	(pDC->SelectObject((CFont *) NULL))->GetLogFont(&logfont);
//	m_fontWhat.CreateFontIndirect(&logfont);
//	m_fontFrom.CreateFontIndirect(&logfont);

	CListBox::PreSubclassWindow();
}
