// ChatUserList.cpp : implementation file
//

#include "stdafx.h"
#include "HostileChat.h"
#include "ChatUserList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChatUserList

CChatUserList::CChatUserList()
{
	m_bkColor = GetSysColor(COLOR_BTNFACE);
//	m_bkColor = RGB(0,0,0);
	m_brushFace.CreateSolidBrush(m_bkColor);

	m_imageList.Create(16, 16, ILC_MASK, 2, 1);
	m_imageList.SetBkColor(CLR_NONE);

	HICON hIcon = AfxGetApp()->LoadIcon(IDI_USERFACE); 
	m_imageList.Add(hIcon);

	hIcon = AfxGetApp()->LoadIcon(IDI_USERFACESELECTED); 
	m_imageList.Add(hIcon);

	hIcon = AfxGetApp()->LoadIcon(IDI_CHAT); 
	m_imageList.Add(hIcon);
	m_imageList.Add(hIcon);

	hIcon = AfxGetApp()->LoadIcon(IDI_MESSAGE); 
	m_imageList.Add(hIcon);
	m_imageList.Add(hIcon);

	hIcon = AfxGetApp()->LoadIcon(IDI_MESSAGE_NONE); 
	m_imageList.Add(hIcon);
	m_imageList.Add(hIcon);

	m_fontWhat.CreateFont(16, 0, 0, 0, FW_BOLD, 0, 0, 0, DEFAULT_CHARSET,
		0, 0, DEFAULT_QUALITY, FF_DONTCARE, "Arial Cyr");
	m_rgbFace = RGB(0,0,0);

	m_bShowIcons = false;
	m_uiIconIndex = 0;
}

CChatUserList::~CChatUserList()
{
}


BEGIN_MESSAGE_MAP(CChatUserList, CListBox)
	//{{AFX_MSG_MAP(CChatUserList)
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatUserList message handlers

void CChatUserList::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	int imageIndex = lpDrawItemStruct->itemData;

	CDC* pDC = CDC::FromHandle( lpDrawItemStruct->hDC );

	pDC->SetBkColor(m_bkColor);
	
	if( ((lpDrawItemStruct->itemState & ODS_SELECTED) == ODS_SELECTED) &&
		((lpDrawItemStruct->itemState & ODS_FOCUS) == ODS_FOCUS)) 
	{
		imageIndex = lpDrawItemStruct->itemData + 1;

//		pDC->SetTextColor(COLORREF(lpDrawItemStruct->itemData));
		pDC->SetTextColor(RGB(GetRValue(m_rgbFace) + 40, GetGValue(m_rgbFace) + 40,
			GetBValue(m_rgbFace) + 40));
	}
	else
//		pDC->SetTextColor(COLORREF(lpDrawItemStruct->itemData));
		pDC->SetTextColor(m_rgbFace);

	//,    ODA_DRAWENTIRE
	RECT rect = lpDrawItemStruct->rcItem;

	CFont*	pOldFont = pDC->SelectObject(&m_fontWhat);
	CString title;

	if(m_bShowIcons) {
//		m_imageList.Draw(pDC, imageIndex, CPoint(lpDrawItemStruct->rcItem.right - 20, 
//			lpDrawItemStruct->rcItem.top + 3), ILD_TRANSPARENT);
	
		m_imageList.Draw(pDC, imageIndex, CPoint(0, 
			lpDrawItemStruct->rcItem.top + 3), ILD_TRANSPARENT);
	}
	
	GetText(lpDrawItemStruct->itemID, title);
	pDC->TextOut( lpDrawItemStruct->rcItem.left + 18,
		lpDrawItemStruct->rcItem.top + 3, title );

	pDC->SelectObject(pOldFont);
}

HBRUSH CChatUserList::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	return m_brushFace;
//	return NULL;
}

void CChatUserList::SetFaceFont(COLORREF rgb, CFont & font)
{
	m_rgbFace = rgb;

	LOGFONT logfont;

	font.GetLogFont(&logfont);
	m_fontWhat.DeleteObject();
	m_fontWhat.CreateFontIndirect(&logfont);

}

void CChatUserList::EnableIcons(bool bState)
{
	m_bShowIcons = bState;
}

void CChatUserList::SetIcon(UINT index, UINT bType)
{
	switch(bType) 
	{
	case FACE:
		SetItemData(index, 0);
		break;
	case INCHAT:
		SetItemData(index, 2);
		break;
	case MESSAGE:
		SetItemData(index, 4);
		break;
	}

	RedrawWindow();
}
