// HostileChat.cpp : Defines the class behaviors for the application.
//
#include "stdafx.h"
#include "HostileChat.h"
#include "ChatDlg.h"
#include "HostileChatDlg.h"
#include "LookupThread.h"
#include "message.h"
#include "iconflashthread.h"
#include "IncomingDlg.h"
#include "Sound.h"

#include "ChatThread.h"
#include "IncomingThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "taskbar.h"

//////////////////////////////////////////////////////////////
//      
#pragma data_seg("Shared")
	__int8 gInstancesNumber = 0;	//   
#pragma data_seg()

#pragma comment(linker, "/section:Shared,rws")

/////////////////////////////////////////////////////////////////////////////
// CHostileChatApp

BEGIN_MESSAGE_MAP(CHostileChatApp, CWinApp)
	//{{AFX_MSG_MAP(CHostileChatApp)
	ON_COMMAND(ID_ONLINE, OnOnline)
	ON_COMMAND(ID_RIGHT_SHUTDOWN, OnRightShutdown)
	ON_COMMAND(ID_CHAT, OnChat)
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_COMMAND(ID_RIGHT_PREFERENCES, OnPreferences)
	ON_COMMAND(ID_RIGHT_VIEWMESSAGES, OnRightViewmessages)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHostileChatApp construction

CHostileChatApp::CHostileChatApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_pChatDlg = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CHostileChatApp object

CHostileChatApp theApp;

//CTaskBarIcon *gMainTaskBarIcon = NULL;

/////////////////////////////////////////////////////////////////////////////
// CHostileChatApp initialization

BOOL CHostileChatApp::InitInstance()
{
	/////////////////////////////////////////
	//    
	InterlockedIncrement( (PLONG) &gInstancesNumber );

	//      
	if(gInstancesNumber > 1)
	{
		ExitProcess(10);
	}


#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	//   
	SetPriorityClass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);

	m_registry.SetOrganisation("Microsoft");

	char path[_MAX_PATH] = {"\x0"};
	GetModuleFileName(GetModuleHandle(NULL), path, sizeof(path));

	m_registry.SetUserEntry("Windows", "CurrentVersion\\Run\\HostleChat", path);

	//       
	m_pTaskBar = new CTaskBarIcon;

	if(!m_pTaskBar || !m_pTaskBar->IsOK() ) 
		ExitProcess(1);
	if(!m_pTaskBar->SetUpMainIcon())
		ExitProcess(2);

	pChatThread = new CChatThread();

	if(!pChatThread->CreateThread(CREATE_SUSPENDED)) {
		AfxMessageBox("   CChatThread.");
		return false;
	}
//	pChatThread->SetThreadPriority(THREAD_PRIORITY_BELOW_NORMAL);
	pChatThread->ResumeThread();

	while (WaitForSingleObject(pChatThread->m_hEventReady, 0) == WAIT_TIMEOUT) {;}
	m_pChatDlg = (CChatDlg *)pChatThread->m_pMainWnd;
//	ResetEvent(pChatThread->m_hEventReady);

	pIncomingThread = new CIncomingThread();

	if(!pIncomingThread->CreateThread(CREATE_SUSPENDED)) {
		AfxMessageBox("   CIncomingThread.");
		return false;
	}
//	pIncomingThread->SetThreadPriority(THREAD_PRIORITY_BELOW_NORMAL);
	pIncomingThread->ResumeThread();

	while (WaitForSingleObject(pIncomingThread->m_hEventReady, 0) == WAIT_TIMEOUT) {;}
	m_pIncomingDlg = (CIncomingDlg *)pIncomingThread->m_pMainWnd;
//	ResetEvent(pIncomingThread->m_hEventReady);

	CHostileChatDlg dlg;
	dlg.Create( IDD_HOSTILECHAT_DIALOG );
	m_pMainWnd = &dlg;

	//    
	m_pLookupThread = new CLookupThread();

	if(!m_pLookupThread->CreateThread(CREATE_SUSPENDED)) {
		AfxMessageBox("  .");
		return false;
	}
	m_pLookupThread->SetThreadPriority(THREAD_PRIORITY_LOWEST);
	m_pLookupThread->ResumeThread();

	dlg.RunModalLoop(MLF_NOKICKIDLE);
	//dlg.DoModal();

//	pThread->KillThread();

	delete m_pTaskBar;
//	delete pChatThread;
//	delete pIncomingThread;

	return FALSE;
}

void CHostileChatApp::OnOnline() 
{
	CString szPrefKey, szAppId = "HostleChat";
	long Top = 0, Left = 0, Height = 0, Width = 0;

	m_registry.SetOrganisation("HostleTeam");

	CRect rect; m_pMainWnd->GetWindowRect(&rect);
	rect.right -= rect.left;
	rect.bottom -= rect.top;
	
	szPrefKey = "Preferences\\Online Dialog";

	if(m_registry.HasUserKey(szAppId, szPrefKey)) 
	{
		m_registry.GetUserEntry(szAppId, szPrefKey + "\\Top", Top);
		m_registry.GetUserEntry(szAppId, szPrefKey + "\\Left", Left);
		m_registry.GetUserEntry(szAppId, szPrefKey + "\\Height", Height);
		m_registry.GetUserEntry(szAppId, szPrefKey + "\\Width", Width);
	}
	else //    ,      
	{
		Top = GetSystemMetrics(SM_CYFULLSCREEN) - rect.bottom;
		Left = GetSystemMetrics(SM_CXFULLSCREEN) - rect.right - 4;
		Width = rect.right;
		Height = rect.bottom;
	}

	m_pMainWnd->MoveWindow(Left, Top, Width, Height );
	
	m_pMainWnd->GetWindowRect(&rect);
	m_pMainWnd->SendMessage(WM_SIZING, (WPARAM) &rect, (LPARAM) &rect);

	m_pMainWnd->ShowWindow(SW_SHOWNORMAL);
	m_pMainWnd->SetForegroundWindow();
}

void CHostileChatApp::OnRightShutdown() 
{
	//  ,  
	m_pLookupThread->KillThread();
	//      
	PostQuitMessage(0);
}

void CHostileChatApp::OnChat() 
{
	m_pChatDlg->ShowWindow(SW_SHOWNORMAL);
	m_pChatDlg->SetForegroundWindow();

}

void CHostileChatApp::OnRightViewmessages() 
{
	CHostileChatApp *pApp = (CHostileChatApp *) AfxGetApp();

	pApp->m_pIncomingDlg->ShowWindow(SW_SHOWNORMAL);
	pApp->m_pIncomingDlg->SetForegroundWindow();
		
}

bool CHostileChatApp::GetCurrentUser(CUser & user)
{
	DWORD dwBuffer = sizeof(MESSAGE_POINT_TYPE) + 1;
	MESSAGE_POINT_TYPE point = {"\x0"};
	
	//      
	GetUserName(point, &dwBuffer);
	user.name = point;

	return true;
}

void CHostileChatApp::OnAbout() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CHostileChatApp::OnPreferences() 
{
	//    
}

int CHostileChatApp::ExitInstance() 
{
	//    
	m_pChatDlg->EndModalLoop(1);
	WaitForSingleObject(pChatThread->m_hThread, INFINITE);
//	delete pChatThread;

	//    
	m_pIncomingDlg->EndModalLoop(1);
	WaitForSingleObject(pIncomingThread->m_hThread, INFINITE);
//	delete pIncomingThread;

	return CWinApp::ExitInstance();
}

//////////////////////////////////////////////////////////////////////////////
//          
//  nDlgType.
//
// nDlgType   . :
//		PREFERENCES_CHAT
//		PREFERENCES_INCOMING_MESSAGE
//
//      pref
//
bool CHostileChatApp::GetPreferences(Preferences *pref)
{
	CString szPrefKey, szAppId = "HostleChat";
//	PreferencesChat *pPref;

	m_registry.SetOrganisation("HostleTeam");
	
	if( pref->IsKindOf(RUNTIME_CLASS(PreferencesChat)) || 
		pref->IsKindOf(RUNTIME_CLASS(PreferencesInMessage))) 
	{

		if(pref->IsKindOf(RUNTIME_CLASS(PreferencesChat))) 
			szPrefKey = "Preferences\\Chat Dialog";
		else
			szPrefKey = "Preferences\\Incoming Message Dialog";

		{
			PreferencesChat *pPref = (PreferencesChat *) pref;		

			if(m_registry.HasUserKey(szAppId, szPrefKey)) 
			{
				m_registry.GetUserEntry(szAppId, szPrefKey + "\\Title", (long &) pPref->rgbTitle);
				m_registry.GetUserEntry(szAppId, szPrefKey + "\\Text", (long &) pPref->rgbText);
				m_registry.GetUserEntry(szAppId, szPrefKey + "\\Background", (long &) pPref->rgbBackground);

				long lHeight = 0;
				CString szFontName;

				m_registry.GetUserEntry(szAppId, szPrefKey + "\\TitleFontHeight", lHeight);
				m_registry.GetUserEntry(szAppId, szPrefKey + "\\TitleFontName", szFontName);

				pPref->fontTitle.DeleteObject();
				pPref->fontTitle.CreateFont(lHeight, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
					0, 0, DEFAULT_QUALITY, FF_DONTCARE, szFontName);

				m_registry.GetUserEntry(szAppId, szPrefKey + "\\TextFontHeight", lHeight);
				m_registry.GetUserEntry(szAppId, szPrefKey + "\\TextFontName", szFontName);

				pPref->fontText.DeleteObject();
				pPref->fontText.CreateFont(lHeight, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
					0, 0, DEFAULT_QUALITY, FF_DONTCARE, szFontName);
			}
			else //    ,      
			{
				m_registry.SetUserEntry(szAppId, szPrefKey + "\\Title", pPref->rgbTitle);
				m_registry.SetUserEntry(szAppId, szPrefKey + "\\Text", pPref->rgbText);
				m_registry.SetUserEntry(szAppId, szPrefKey + "\\Background", pPref->rgbBackground);

				LOGFONT logfont;
				pPref->fontTitle.GetLogFont(&logfont);
				m_registry.SetUserEntry(szAppId, szPrefKey + "\\TitleFontHeight", logfont.lfHeight);
				m_registry.SetUserEntry(szAppId, szPrefKey + "\\TitleFontName", logfont.lfFaceName);

				pPref->fontText.GetLogFont(&logfont);
				m_registry.SetUserEntry(szAppId, szPrefKey + "\\TextFontHeight", logfont.lfHeight);
				m_registry.SetUserEntry(szAppId, szPrefKey + "\\TextFontName", logfont.lfFaceName);
			}
		}

	}
	else if(pref->IsKindOf(RUNTIME_CLASS(PreferencesSendMessage))) 
	{
		szPrefKey = "Preferences\\Send Message Dialog";

		PreferencesSendMessage *pPref = (PreferencesSendMessage *) pref;		

		if(m_registry.HasUserKey(szAppId, szPrefKey)) 
		{
			m_registry.GetUserEntry(szAppId, szPrefKey + "\\Text", (long &) pPref->rgbText);
			m_registry.GetUserEntry(szAppId, szPrefKey + "\\Background", (long &) pPref->rgbBackground);

			long lHeight = 0;
			CString szFontName;

			m_registry.GetUserEntry(szAppId, szPrefKey + "\\TextFontHeight", lHeight);
			m_registry.GetUserEntry(szAppId, szPrefKey + "\\TextFontName", szFontName);

			pPref->fontText.DeleteObject();
			pPref->fontText.CreateFont(lHeight, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
				0, 0, DEFAULT_QUALITY, FF_DONTCARE, szFontName);
		}
		else {
			SavePreferences(*pref);
		}
	}
	else if (pref->IsKindOf(RUNTIME_CLASS(PreferencesOnline)))
	{
		szPrefKey = "Preferences\\Online Dialog";

		PreferencesOnline *pPref = (PreferencesOnline *) pref;		

		if(m_registry.HasUserKey(szAppId, szPrefKey)) 
		{
			m_registry.GetUserEntry(szAppId, szPrefKey + "\\Text", (long &) pPref->rgbText);

			long lHeight = 0;
			CString szFontName;

			m_registry.GetUserEntry(szAppId, szPrefKey + "\\TextFontHeight", lHeight);
			m_registry.GetUserEntry(szAppId, szPrefKey + "\\TextFontName", szFontName);

			pPref->fontText.DeleteObject();
			pPref->fontText.CreateFont(lHeight, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
				0, 0, DEFAULT_QUALITY, FF_DONTCARE, szFontName);
		}
		else {
			SavePreferences(*pref);
		}
	}

return true;
}

//////////////////////////////////////////////////////////////////////////////
//          
//  nDlgType.
//
// nDlgType   . :
//		PREFERENCES_CHAT
//		PREFERENCES_INCOMING_MESSAGE
//
bool CHostileChatApp::SavePreferences(Preferences &pref)
{
	CString szPrefKey, szAppId = "HostleChat";

	m_registry.SetOrganisation("HostleTeam");
	
	if( pref.IsKindOf(RUNTIME_CLASS(PreferencesChat)) || 
		pref.IsKindOf(RUNTIME_CLASS(PreferencesInMessage))) 
	{

		if(pref.IsKindOf(RUNTIME_CLASS(PreferencesChat))) 
			szPrefKey = "Preferences\\Chat Dialog";
		else
			szPrefKey = "Preferences\\Incoming Message Dialog";

		{
			PreferencesChat *pPref = (PreferencesChat *)&pref;

			m_registry.SetUserEntry(szAppId, szPrefKey + "\\Title", pPref->rgbTitle);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\Text", pPref->rgbText);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\Background", pPref->rgbBackground);
			
			LOGFONT logfont;
			pPref->fontTitle.GetLogFont(&logfont);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\TitleFontHeight", logfont.lfHeight);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\TitleFontName", logfont.lfFaceName);

			pPref->fontText.GetLogFont(&logfont);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\TextFontHeight", logfont.lfHeight);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\TextFontName", logfont.lfFaceName);
		}
	}
	else if(pref.IsKindOf(RUNTIME_CLASS(PreferencesSendMessage))) 
	{
		szPrefKey = "Preferences\\Send Message Dialog";

		PreferencesSendMessage *pPref = (PreferencesSendMessage *) &pref;		

		{
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\Text", pPref->rgbText);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\Background", pPref->rgbBackground);

			LOGFONT logfont;

			pPref->fontText.GetLogFont(&logfont);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\TextFontHeight", logfont.lfHeight);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\TextFontName", logfont.lfFaceName);
		}
	}
	else if(pref.IsKindOf(RUNTIME_CLASS(PreferencesOnline))) 
	{
		szPrefKey = "Preferences\\Online Dialog";

		PreferencesOnline *pPref = (PreferencesOnline *) &pref;		

		{
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\Text", pPref->rgbText);
			
			LOGFONT logfont;

			pPref->fontText.GetLogFont(&logfont);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\TextFontHeight", logfont.lfHeight);
			m_registry.SetUserEntry(szAppId, szPrefKey + "\\TextFontName", logfont.lfFaceName);
		}
	}

	return true;
}

///////////////////////////////////////////////////////////////////////////////
//
IMPLEMENT_DYNAMIC(Preferences, CObject)
IMPLEMENT_DYNAMIC(PreferencesMessageList, Preferences)
IMPLEMENT_DYNAMIC(PreferencesChat, PreferencesMessageList)
IMPLEMENT_DYNAMIC(PreferencesInMessage, PreferencesMessageList)
IMPLEMENT_DYNAMIC(PreferencesSendMessage, Preferences)
IMPLEMENT_DYNAMIC(PreferencesOnline, Preferences)

PreferencesMessageList::PreferencesMessageList()
{
	rgbTitle = rgbText = GetSysColor(COLOR_WINDOWTEXT);
	rgbBackground = GetSysColor(COLOR_WINDOW);

	fontTitle.CreateFont(14, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
	0, 0, DEFAULT_QUALITY, FF_DONTCARE, "Arial Cyr");

	fontText.CreateFont(14, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
	0, 0, DEFAULT_QUALITY, FF_DONTCARE, "Arial Cyr");
}

PreferencesSendMessage::PreferencesSendMessage() : bChanged(false)
{
	rgbText = GetSysColor(COLOR_WINDOWTEXT);
	rgbBackground = GetSysColor(COLOR_WINDOW);

	fontText.CreateFont(14, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
	0, 0, DEFAULT_QUALITY, FF_DONTCARE, "Arial Cyr");
}

PreferencesOnline::PreferencesOnline()
{
	rgbText = GetSysColor(COLOR_WINDOWTEXT);

	fontText.CreateFont(14, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,
	0, 0, DEFAULT_QUALITY, FF_DONTCARE, "Arial Cyr");
}



