// HostileChat.h : main header file for the HOSTILECHAT application
//

#if !defined(AFX_HOSTILECHAT_H__26BF6375_A59A_11D3_9315_004095817FB2__INCLUDED_)
#define AFX_HOSTILECHAT_H__26BF6375_A59A_11D3_9315_004095817FB2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "AboutDlg.h"
#include "message.h"
#include "PostOffice.h"	// Added by ClassView
#include "chatdlg.h"
#include "taskbar.h"
#include "REGISTRY.H"	// Added by ClassView
#include "IncomingDlg.h"	// Added by ClassView

#include "ChatThread.h"
#include "IncomingThread.h"
/////////////////////////////////////////////////////////////////////////////
// CHostileChatApp:
// See HostileChat.cpp for the implementation of this class
//

#define WM_RECIEVE_MESSAGE		WM_USER + 1000
#define WM_TASKBAR_EVENT		WM_USER + 1001
#define WM_UPDATE_USER			WM_USER + 1002
#define WM_USER_IN_CHAT			WM_USER + 1003
#define WM_FLASH_IN_MESSAGE		WM_USER + 1004
#define WM_SEND_MESSAGE			WM_USER + 1005
#define WM_BROADCAST			WM_USER + 1006

#define EVENT_INCOMING_MESSAGE	1
#define EVENT_NEW_USER			2

#define PREFERENCES_CHAT					1
#define PREFERENCES_INCOMING_MESSAGE		2

class Preferences;
class PreferencesMessageList;
class PreferencesChat;
class PreferencesInMessage;

class CHostileChatApp : public CWinApp
{
	friend class CLookupThread;

public:
	CChatDlg * m_pChatDlg;
	CIncomingDlg *m_pIncomingDlg;

public:
	bool SavePreferences(Preferences &);
	bool GetPreferences(Preferences*);
	CRegistry m_registry;
	CTaskBarIcon * m_pTaskBar;
	bool GetCurrentUser( CUser &user );
	CHostileChatApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHostileChatApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CHostileChatApp)
	afx_msg void OnOnline();
	afx_msg void OnRightShutdown();
	afx_msg void OnChat();
	afx_msg void OnAbout();
	afx_msg void OnPreferences();
	afx_msg void OnRightViewmessages();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CLookupThread * m_pLookupThread;
	CIncomingThread * pIncomingThread;
	CChatThread * pChatThread;
};


/////////////////////////////////////////////////////////////////////////////
class Preferences : public CObject
{
public:
	Preferences() {;}

	DECLARE_DYNAMIC(Preferences)
};

class PreferencesMessageList : public Preferences 
{
	// Attributes
public:
	COLORREF rgbTitle, 
			 rgbText, 
			 rgbBackground; //  
	CFont	 fontTitle,
			 fontText;

	// Member functions
	PreferencesMessageList();

	DECLARE_DYNAMIC(PreferencesMessageList)
};

class PreferencesChat : public PreferencesMessageList 
{
public:

	PreferencesChat() {;}

	DECLARE_DYNAMIC(PreferencesChat)
};

class PreferencesInMessage : public PreferencesMessageList 
{
public:

	PreferencesInMessage() {;}

	DECLARE_DYNAMIC(PreferencesInMessage)
};

class PreferencesSendMessage: public Preferences
{
public:
	CFont fontText;
	COLORREF rgbBackground;
	COLORREF rgbText;
	PreferencesSendMessage();
	bool bChanged;

	DECLARE_DYNAMIC(PreferencesSendMessage);
};

class PreferencesOnline: public Preferences
{
public:
	CFont fontText;
	COLORREF rgbText;
	PreferencesOnline();

	DECLARE_DYNAMIC(PreferencesOnline)
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HOSTILECHAT_H__26BF6375_A59A_11D3_9315_004095817FB2__INCLUDED_)
