// HostileChatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HostileChat.h"
#include "HostileChatDlg.h"
#include "MessageDlg.h"
#include "ChatDlg.h"
#include "Message.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHostileChatDlg dialog

CHostileChatDlg::CHostileChatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHostileChatDlg::IDD, pParent),
	m_btnFont(IDB_FONT, IDB_FONT_MASK, CSize(15,15)),
	m_btnColor(IDB_COLOR, IDB_COLOR_MASK, CSize(15,15)),
	m_btnTopMost(IDB_NONTOP, IDB_NONTOP_MASK, CSize(15,15))
{
	//{{AFX_DATA_INIT(CHostileChatDlg)
	//m_szEdit = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in iWn32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bTopMost = false;
}

void CHostileChatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHostileChatDlg)
	DDX_Control(pDX, IDC_TOPMOST, m_btnTopMost);
	DDX_Control(pDX, IDC_COLOR, m_btnColor);
	DDX_Control(pDX, IDC_FONT, m_btnFont);
	DDX_Control(pDX, IDC_USERLIST, m_userList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHostileChatDlg, CDialog)
	//{{AFX_MSG_MAP(CHostileChatDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_LBN_DBLCLK(IDC_USERLIST, OnDblclkUserlist)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_MESSAGE(WM_UPDATE_USER, OnUpdateUserList)
	ON_MESSAGE(WM_SEND_MESSAGE, OnSendMessage)
	ON_MESSAGE(WM_FLASH_IN_MESSAGE, OnFlashIncomingMessage)
	ON_BN_CLICKED(IDC_COLOR, OnColor)
	ON_BN_CLICKED(IDC_FONT, OnFont)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_TOPMOST, OnTopmost)
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZING()
	ON_BN_CLICKED(IDC_SEND, OnDblclkUserlist)
	ON_WM_ACTIVATE()
	ON_MESSAGE(WM_BROADCAST, OnBroadcast)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHostileChatDlg message handlers

BOOL CHostileChatDlg::OnInitDialog()
{
	if(!m_PostOffice.IsValid())
		ExitProcess(10);

	CDialog::OnInitDialog();

	///////////////////////////////////////////////////////
	//     online 
	m_userList.AddString("All");
	//    ,   All
	CUser user; user.name = "All!";
	m_users.Add(user);

	m_userList.EnableIcons(true);

	((CHostileChatApp *)AfxGetApp())->GetPreferences(&m_pref);
	m_userList.SetFaceFont(m_pref.rgbText, m_pref.fontText);

	SetTimer(TIMER_CONFIRM_PRESENSE, 1000, NULL ); //   

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHostileChatDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHostileChatDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CHostileChatDlg::PreCreateWindow(CREATESTRUCT& cs) 
{
//	cs.style &= ~WS_VISIBLE;
	
	return CDialog::PreCreateWindow(cs);
}

void CHostileChatDlg::OnClose() 
{
	CString szPrefKey, szAppId = "HostleChat";

	szPrefKey = "Preferences\\Online Dialog";

	CHostileChatApp *pApp = (CHostileChatApp *) AfxGetApp();

	CRect rect; GetWindowRect(&rect);

	pApp->m_registry.SetOrganisation("HostleTeam");
	pApp->m_registry.SetUserEntry(szAppId, szPrefKey + "\\Top", rect.top);
	pApp->m_registry.SetUserEntry(szAppId, szPrefKey + "\\Left", rect.left);
	pApp->m_registry.SetUserEntry(szAppId, szPrefKey + "\\Height", rect.bottom - rect.top);
	pApp->m_registry.SetUserEntry(szAppId, szPrefKey + "\\Width", rect.right - rect.left);

	ShowWindow(SW_HIDE);	
	//CDialog::OnClose();
}

void CHostileChatDlg::OnDblclkUserlist() 
{
	CString sztoUser;
	//   
	m_userList.GetText(m_userList.GetCurSel(), sztoUser);	

	OpenSendMessageDlg(sztoUser);
}

void CHostileChatDlg::OnTimer(UINT nIDEvent) 
{
	static CMessage message;

	CHostileChatApp *pApp = (CHostileChatApp *) AfxGetApp();

	switch(nIDEvent) 
	{
		case TIMER_CONFIRM_PRESENSE:
		{
			DWORD dwBuffer = sizeof(MESSAGE_POINT_TYPE) + 1;

			strcpy(message.contents, "...");
			//      
			GetUserName(message.creator, &dwBuffer);
			message.id = CMessage::MID_CONFIRM_PRESENSE;

			pApp->m_pMainWnd->SendMessage(WM_BROADCAST, (DWORD) &message, TYPE_MESSAGE);

			for(int i = 0; i < m_users.GetSize(); i++) 
			{
				//      , 
				//    
				int index = m_userList.FindStringExact(0, m_users[i].name);

				//       online,  
				//    
				if(m_users[i].bOnline) 
				{
					if(m_users[i].online_counter <= 0) 
					{
						if(index > -1) { //       
							m_userList.DeleteString(index);	

							m_users.RemoveAt(i); //   
							i--;
							continue;
						}
					}
					else m_users[i].online_counter--;
				}

				//        
				if(m_users[i].bInchat) 
				{
					if(m_users[i].inchat_counter <= 0) {
						m_userList.SetIcon(index, CChatUserList::FACE);
//						m_userList.SetItemData(index, 0x00);
//						m_userList.SetFaceFont(m_pref.rgbText, m_pref.fontText);

						m_users[i].bInchat = false;
						//m_userList.Invalidate();
					}
					else m_users[i].inchat_counter--;
				}
			}

			UpdateData(false);
		}
		break;
	}

	CDialog::OnTimer(nIDEvent);
}

//////////////////////////////////////////////////////////////////////
//      WM_UPDATE_USER
//
//    ,  
//   UPDATE_ONLINE, UPDATE_INCHAT
//
void CHostileChatDlg::OnUpdateUserList(WPARAM wParam, LPARAM lParam)
{
	CMessage *message = (CMessage *) wParam;
	CUser user = MessageToUser(*message);
	CHostileChatApp *pApp = (CHostileChatApp *) AfxGetApp();

	switch(lParam) 
	{
	case UPDATE_ONLINE:
		{
		int nPresense = 0;

		// ,    
		for( int i = 0; i < m_users.GetSize(); i++) 
		{	
			// ,        
			if(strcmp(m_users[i].name, user.name) == 0) 
			{
				nPresense = i;
				break;
			}
		}

		if(nPresense) {
			m_users[nPresense].bOnline = true;
			m_users[nPresense].online_counter = ONLINE_UPPER_TIME;
		}
		else {
			//     ,   
			user.bOnline = true;
			user.online_counter = ONLINE_UPPER_TIME;

			m_users.Add(user);
			m_userList.AddString(user.name);

			::PostMessage(pApp->m_pTaskBar->GetHWND(), WM_TASKBAR_EVENT, 
			EVENT_NEW_USER, 0);
		}
		}
		break;
	case UPDATE_INCHAT:
		{
			for( int i = 0; i < m_users.GetSize(); i++) 
			{	
				// ,        
				if(strcmp(m_users[i].name, user.name) == 0) 
				{
					int index = m_userList.FindString(0, user.name);
					
					if( index > -1 ) // 
					{
						m_users[i].inchat_counter = 4;
						
						if( !m_users[i].bInchat ) {
//							m_userList.SetItemData(index, 0xff);
//							m_userList.Invalidate();
							m_userList.SetIcon(index, CChatUserList::INCHAT);
							m_users[i].bInchat = true;

//							m_userList.Invalidate();
						}
					}
					break;
				}
			}
		}
		break;
	}

	delete message;
}

void CHostileChatDlg::OnFlashIncomingMessage(WPARAM wp, LPARAM lp)
{
	LPCSTR lpszUser = (LPCSTR) wp;
	int index = m_userList.FindString(0, (LPCSTR) wp);

	if( index > -1 ) 
	{
		m_userList.SetIcon(index, lp);
	}
}

BOOL CHostileChatDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if( wParam == WM_DESTROY) {
		OnClose();
		return true;
	}
	else
		return CDialog::OnCommand(wParam, lParam);
}

CUser CHostileChatDlg::MessageToUser(CMessage & message)
{
	CUser user; user.name = message.creator; //user.computer = message.contents;
	return user;
}

void CHostileChatDlg::OnColor() 
{
	CColorDialog dlg(m_pref.rgbText);

	if(dlg.DoModal() == IDOK) {
		m_pref.rgbText = dlg.GetColor();
		m_userList.SetFaceFont(m_pref.rgbText, m_pref.fontText);

		((CHostileChatApp *)AfxGetApp())->SavePreferences(m_pref);

		m_userList.RedrawWindow();
		m_userList.UpdateData(false);
	}
	m_btnColor.ResetState();
}

void CHostileChatDlg::OnFont() 
{
	LOGFONT logFont;

	m_pref.fontText.GetLogFont(&logFont);

	CFontDialog dlg(&logFont);
	if(dlg.DoModal() == IDOK) 
	{
		dlg.GetCurrentFont(&logFont);
		m_pref.fontText.DeleteObject();
		m_pref.fontText.CreateFontIndirect(&logFont);
		m_userList.SetFaceFont(m_pref.rgbText, m_pref.fontText);

		((CHostileChatApp *)AfxGetApp())->SavePreferences(m_pref);

		m_userList.RedrawWindow();
		m_userList.UpdateData(false);
	}
	m_btnFont.ResetState();
}

void CHostileChatDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	m_btnFont.ResetState();
	m_btnColor.ResetState();
	m_btnTopMost.ResetState();
}

void CHostileChatDlg::OnSendMessage(WPARAM wp, LPARAM lp)
{
	if( wp ) {
		CString whom = (LPCSTR)wp;
		OpenSendMessageDlg(whom);
	}
}

void CHostileChatDlg::OpenSendMessageDlg(LPCSTR lpszWhom)
{
	CString username(lpszWhom);

	CMessageDlg dlg(username);
	
	if (dlg.m_uiRef > 1) {
		dlg.pSelf->SetActiveWindow();
		return;
	}

	//     'send',  
	if ( dlg.DoModal() == IDOK)
	{

		if ( dlg.m_szMessage == "" ) return; //     !

		CHostileChatApp *pApp = (CHostileChatApp *) AfxGetApp();
		CMessage message;
		DWORD dwBuffer = sizeof(MESSAGE_CONTENTS_TYPE) + 1;

		//      
		GetUserName(message.creator, &dwBuffer);

		//    -   online  
		strcpy(message.addressee, lpszWhom);
		message.id = CMessage::MID_BROADCAST;

		CString sztoUserCheck;

		BOOL flag = false;  //    user
	   	for(int j = 0; j < m_userList.GetCount() - 1; j++)
		{
			m_userList.GetText(j, sztoUserCheck);
			if ( username = sztoUserCheck)
			{
				strcpy(message.contents, dlg.m_szMessage);
				pApp->m_pMainWnd->SendMessage(WM_BROADCAST, (DWORD) &message, TYPE_MESSAGE);
//				pOffice->Broadcast( message );
				flag = true;
			}
		}
		if (!flag) MessageBox(" User'a    . \n  .", "Warning"); 
	}
}

void CHostileChatDlg::OnTopmost() 
{
	// TODO: Add your control notification handler code here
	if(m_bTopMost) {
		SetWindowPos(&wndBottom, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

		m_bTopMost = false;

		m_btnTopMost.SetPictures(IDB_NONTOP, IDB_NONTOP_MASK);
		ShowWindow(SW_SHOW);
	}
	else {
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
		m_bTopMost = true;

		m_btnTopMost.SetPictures(IDB_TOP, IDB_TOP_MASK);
	}
  UpdateData(false);
}

void CHostileChatDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	lpMMI->ptMinTrackSize.x = 80;
	lpMMI->ptMinTrackSize.y = 150;
	
	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CHostileChatDlg::OnSizing(UINT fwSide, LPRECT pRect) 
{
	CDialog::OnSizing(fwSide, pRect);
	
	HDWP	hdwp;

	hdwp = BeginDeferWindowPos(4);
	if(hdwp == NULL) return;

	//   
	DeferWindowPos(hdwp, m_btnFont.GetSafeHwnd(), NULL, 
		(pRect->right - pRect->left) - 32, 
		(pRect->bottom - pRect->top) - 47,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	DeferWindowPos(hdwp, m_btnColor.GetSafeHwnd(), NULL, 
		(pRect->right - pRect->left) - 50, 
		(pRect->bottom - pRect->top) - 47,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	DeferWindowPos(hdwp, m_btnTopMost.GetSafeHwnd(), NULL, 
		8, 
		(pRect->bottom - pRect->top) - 47,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	DeferWindowPos(hdwp, m_userList.GetSafeHwnd(), NULL, 0, 0,
		(pRect->right - pRect->left) - 24, 
		(pRect->bottom - pRect->top) - 61,
		SWP_NOZORDER | SWP_NOMOVE);

	EndDeferWindowPos(hdwp);
}

void CHostileChatDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);
	
	m_btnFont.ResetState();
	m_btnColor.ResetState();
	m_btnTopMost.ResetState();
}

void CHostileChatDlg::OnBroadcast(WPARAM wParm, LPARAM lParm)
{
	if(!wParm) return;

	switch(lParm) 
	{
	case TYPE_MESSAGE:
		{
			CMessage &message = *((CMessage*) wParm);
			m_PostOffice.Broadcast(message);
		}
		break;
	case TYPE_USER:
		{
			CUser &user = *((CUser*) wParm);
			m_PostOffice.Broadcast(user);
		}
		break;
	}
}
