// IconFlashThread.cpp : implementation file
//

#include "stdafx.h"
#include "hostilechat.h"
#include "IconFlashThread.h"
#include "ChatUserList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIconFlashThread

IMPLEMENT_DYNCREATE(CIconFlashThread, CWinThread)

CIconFlashThread::CIconFlashThread()
{
}

CIconFlashThread::CIconFlashThread(HICON hIcon, HICON hIcon2, long lTime,
								   LPCSTR lpszTip, LPCSTR lpszUser) :
	CWinThread(), m_lTime(lTime), m_lpszTip(lpszTip), m_sUser(lpszUser)
{
	m_hIcon = hIcon; m_hNoneIcon = hIcon2;

	m_hEventKill = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_hEventDead = CreateEvent(NULL, TRUE, FALSE, NULL);
}

CIconFlashThread::~CIconFlashThread()
{
	CloseHandle(m_hEventKill);
	CloseHandle(m_hEventDead);
}

BOOL CIconFlashThread::InitInstance()
{
	CHostileChatApp *pApp = (CHostileChatApp *)AfxGetApp();
	long iCounter = 0;
	bool bIconSetuped = false, bNoneIconSetuped = false, bState = true;

	pApp->m_pTaskBar->SetIcon(m_hIcon, m_lpszTip);

	while (WaitForSingleObject(m_hEventKill, 0) == WAIT_TIMEOUT)
	{
		Sleep(500); //       ..._LOWEST

		if( bState ) {
			pApp->m_pTaskBar->SetIcon(m_hNoneIcon, m_lpszTip);

//			pApp->m_pMainWnd->PostMessage(WM_FLASH_IN_MESSAGE, 
//				(WPARAM) (LPCSTR) m_sUser, CChatUserList::NONE);
			bState = false;
		}
		else {
			pApp->m_pTaskBar->SetIcon(m_hIcon, m_lpszTip);
//			pApp->m_pMainWnd->PostMessage(WM_FLASH_IN_MESSAGE, 
//				(WPARAM) (LPCSTR) m_sUser, CChatUserList::MESSAGE);

			bState = true;
		}

		if((m_lTime > 0)) {
			if( iCounter >= m_lTime ) 
			{
				pApp->m_pTaskBar->FinishEvent();
				break;
			}
		}

		iCounter++;
	}
	// avoid entering standard message loop by returning FALSE
	return FALSE;
}

int CIconFlashThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
//	((CHostileChatApp *)AfxGetApp())->m_pMainWnd->
///		PostMessage(WM_FLASH_IN_MESSAGE,
//			(WPARAM) (LPCSTR) m_sUser, CChatUserList::FACE);


	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CIconFlashThread, CWinThread)
	//{{AFX_MSG_MAP(CIconFlashThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIconFlashThread message handlers

void CIconFlashThread::KillThread()
{
	SetEvent(m_hEventKill);

	// allow thread to run at higher priority during kill process
	SetThreadPriority(THREAD_PRIORITY_ABOVE_NORMAL);
	WaitForSingleObject(m_hEventDead, INFINITE);
	WaitForSingleObject(m_hThread, INFINITE);

	// now delete CWinThread object since no longer necessary
	delete this;

}

void CIconFlashThread::Delete()
{
	SetEvent(m_hEventDead);
}
