// IncomingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "hostilechat.h"
#include "IncomingDlg.h"
#include "Preferences.h"
#include "Sound.h"
#include "MessageDlg.h"
#include "HostileChatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIncomingDlg dialog


CIncomingDlg::CIncomingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIncomingDlg::IDD, pParent),
	m_btnProperties(IDB_PROPERTIES, IDB_PROPERTIES_MASK, CSize(31,31)),
	m_btnMessage(IDB_MESSAGEC_BTN, IDB_MESSAGEC_BTN_MASK, CSize(24, 18))
//	m_btnReply(IDB_REPLY, IDB_REPLY_MASK, CSize(31,31))
{
	//{{AFX_DATA_INIT(CIncomingDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_MESSAGE);
	m_iNewMessage = m_iLastSelection = 0;
}


void CIncomingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIncomingDlg)
	DDX_Control(pDX, IDC_MESSAGE_BTN, m_btnMessage);
	DDX_Control(pDX, IDOK, m_btnClose);
	DDX_Control(pDX, IDC_REPLY, m_btnReply);
	DDX_Control(pDX, IDC_MESSAGEDATA, m_stmsginf);
	DDX_Control(pDX, IDC_PROPERTIES, m_btnProperties);
	DDX_Control(pDX, IDC_MESSAGES, m_messageList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIncomingDlg, CDialog)
	//{{AFX_MSG_MAP(CIncomingDlg)
	ON_WM_SHOWWINDOW()
	ON_WM_CLOSE()
	ON_MESSAGE(WM_RECIEVE_MESSAGE, OnRecieveMessage)
	ON_BN_CLICKED(IDC_PROPERTIES, OnProperties)
	ON_CONTROL(WM_VSCROLL, IDC_MESSAGES, OnSelchangeMessages)
	ON_BN_CLICKED(IDC_REPLY, OnReply)
	ON_WM_ACTIVATE()
	ON_WM_TIMER()
	ON_WM_WINDOWPOSCHANGING()
	ON_WM_SIZE()
	ON_WM_SIZING()
	ON_WM_WINDOWPOSCHANGED()
	ON_LBN_SELCHANGE(IDC_MESSAGES, OnSelchangeMessages)
	ON_WM_GETMINMAXINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIncomingDlg message handlers

void CIncomingDlg::OnRecieveMessage(WPARAM wParm, LPARAM lParm)
{
	CMessage *message = (CMessage *) wParm;
	CString name, contents;

	name = message->creator;
	contents = message->contents;
	CTime time = CTime::GetCurrentTime();
	CString sztime = time.Format("%H:%M");
	m_messageList.AddString(name + "%" + "[" + sztime + "] " + contents); //  

	CString szCount;
/*
	wndTop.GetWindowText(szCount);
	sztime = szCount;
	wndBottom.GetWindowText(szCount);
	sztime += ", " + szCount;
	wndTopMost.GetWindowText(szCount);
	sztime += ", " + szCount;
	wndNoTopMost.GetWindowText(szCount);
	sztime += ", " + szCount;

	AfxMessageBox(sztime);
*/
//	GetTopWindow()->GetWindowText(szCount);
//	AfxMessageBox(szCount);
//	WINDOWPLACEMENT wplace;

//	GetWindowPlacement(&wplace);
//	szCount.Format("%d,%d,%d", wplace.showCmd, SW_SHOWNA, SW_SHOWNOACTIVATE);
///	AfxMessageBox(szCount);

	if( *GetForegroundWindow() != *this) 
	{
		if( IsWindowVisible() ) 
		{
			m_messageList.SetTopIndex(m_messageList.GetCount() - m_iNewMessage - 1);

			szCount.Format("%d : %d", m_messageList.GetCount() - m_iNewMessage,
				m_messageList.GetCount());  // - 

			if( m_iNewMessage >= 1) {
				SetTimer(1, 300, NULL);
			}

			m_iNewMessage++;
		}
		else {
			//      ,   
			//    
			m_messageList.SetTopIndex(m_messageList.GetCount() -1);

			szCount.Format("%d : %d", m_messageList.GetCount(),
				m_messageList.GetCount());  // - 
			//       
			m_iNewMessage = 0;
		}
	}
	else {
//		if(
		m_iNewMessage = m_messageList.GetCount() - (m_iLastSelection + 1);

		szCount.Format("%d : %d", m_messageList.GetCount() - m_iNewMessage,
			m_messageList.GetCount());  // - 

		SetTimer(1, 300, NULL);
	}

	 //   
	m_stmsginf.SetWindowText(szCount); 
	
	CSound::PlayResource(ID_SOUND_INCOMING); 
	delete message;
}

BOOL CIncomingDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, FALSE);		// Set small icon

	//        
	PreferencesInMessage prefMList;
	((CHostileChatApp*) AfxGetApp())->GetPreferences(&prefMList);

	m_messageList.SetFromProperties(prefMList.rgbTitle, prefMList.fontTitle);
	m_messageList.SetWhatProperties(prefMList.rgbText, prefMList.fontText);
	m_messageList.SetBkColor(prefMList.rgbBackground);
	
	CRect rect;
	m_messageList.GetClientRect(&rect);
	m_messageList.SetItemHeight(rect.bottom);

	CString szText = "0 : 0";
	m_stmsginf.SetWindowText(szText); 

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CIncomingDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
}

void CIncomingDlg::OnClose() 
{
		
//	CDialog::OnClose();
	ShowWindow(SW_HIDE);
}

BOOL CIncomingDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if( wParam == WM_DESTROY) {
		OnClose();
		return true;
	}
	else
		return CDialog::OnCommand(wParam, lParam);
}

void CIncomingDlg::OnOK() 
{
	OnClose();	
}

void CIncomingDlg::OnProperties() 
{
	CPreferences dlg(RUNTIME_CLASS(PreferencesInMessage));

	if(dlg.DoModal() == IDOK) {
		//        
		PreferencesInMessage prefMList;
		((CHostileChatApp*) AfxGetApp())->GetPreferences(&prefMList);

		m_messageList.SetFromProperties(prefMList.rgbTitle, prefMList.fontTitle);
		m_messageList.SetWhatProperties(prefMList.rgbText, prefMList.fontText);
		m_messageList.SetBkColor(prefMList.rgbBackground);
		
		m_messageList.RedrawWindow();
		UpdateData(false);
	}
	
}

void CIncomingDlg::OnSelchangeMessages() 
{
	m_iLastSelection = m_messageList.GetCurSel();
	//       ,    
	//  
	if( m_iNewMessage > 0 )
	{ 
		m_iNewMessage = m_messageList.GetCount() - m_iLastSelection;

		if( m_iNewMessage == 1) {
			KillTimer(1);
//			m_stMessageIcon.ShowWindow(SW_HIDE);

			m_iNewMessage = 0;
		}
	}

	m_messageList.SetTopIndex(m_iLastSelection); //   

	CString szCount;

	szCount.Format("%d : %d", m_messageList.GetTopIndex() + 1,
		m_messageList.GetCount());
	m_stmsginf.SetWindowText(szCount);
}

void CIncomingDlg::OnReply() 
{
	static CString sztoUser;

	if ( m_messageList.GetCount() == 0 ) return;

	//   
	m_messageList.GetText(m_messageList.GetTopIndex(), sztoUser);	
	sztoUser = sztoUser.Left(sztoUser.Find("%"));

	((CHostileChatApp *)AfxGetApp())->m_pMainWnd->
		PostMessage(WM_SEND_MESSAGE, (DWORD) (LPCSTR) sztoUser, 0);

	OnClose();	
}


void CIncomingDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);

	if( nState == WA_ACTIVE ) {
		if( m_iNewMessage ) {
			CHostileChatApp *pApp = (CHostileChatApp *) AfxGetApp();

			//       
			::PostMessage(pApp->m_pTaskBar->GetHWND(), CTaskBarIcon::sm_taskbarMsg,
				0, WM_LBUTTONDOWN);

			SetActiveWindow();
		}
	}
}

void CIncomingDlg::OnTimer(UINT nIDEvent) 
{
	static UINT uiState = SW_HIDE;

//	m_stMessageIcon.ShowWindow(uiState);
//	m_btnMessage.ShowWindow(uiState);
	if(uiState == SW_SHOW)
		m_btnMessage.SetPictures(IDB_MESSAGE_BTN, IDB_MESSAGE_BTN_MASK);
	else
		m_btnMessage.SetPictures(IDB_MESSAGEC_BTN, IDB_MESSAGEC_BTN_MASK);


	uiState = (uiState == SW_HIDE ? SW_SHOW : SW_HIDE);
	
	CDialog::OnTimer(nIDEvent);
}

void CIncomingDlg::OnWindowPosChanging(WINDOWPOS FAR* lpwndpos) 
{
	CDialog::OnWindowPosChanging(lpwndpos);

}

void CIncomingDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	
}

void CIncomingDlg::OnSizing(UINT fwSide, LPRECT pRect) 
{
	CDialog::OnSizing(fwSide, pRect);
	
	
}

void CIncomingDlg::OnWindowPosChanged(WINDOWPOS FAR* lpwndpos) 
{
	HDWP	hdwp;

	hdwp = BeginDeferWindowPos(5);
	if(hdwp == NULL) return;

	DeferWindowPos(hdwp, m_btnClose.GetSafeHwnd(), NULL, 
		lpwndpos->cx - 77, 
		lpwndpos->cy - 53,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	DeferWindowPos(hdwp, m_btnReply.GetSafeHwnd(), NULL, 
		lpwndpos->cx - 146, 
		lpwndpos->cy - 53,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	DeferWindowPos(hdwp, m_btnProperties.GetSafeHwnd(), NULL, 
		3, 
		lpwndpos->cy - 58,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	DeferWindowPos(hdwp, m_messageList.GetSafeHwnd(), NULL, 3, 5,
		lpwndpos->cx - 13, 
		lpwndpos->cy - 63,
		SWP_NOZORDER );

	DeferWindowPos(hdwp, m_btnMessage.GetSafeHwnd(), NULL, 
		lpwndpos->cx -175, 
		lpwndpos->cy - 51,
		0, 0, SWP_NOZORDER | SWP_NOSIZE);

	EndDeferWindowPos(hdwp);	

	m_messageList.SetItemHeight(lpwndpos->cy - 63);
	UpdateData(false);

	CDialog::OnWindowPosChanged(lpwndpos);
}

void CIncomingDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	lpMMI->ptMinTrackSize.x = 200;
	lpMMI->ptMinTrackSize.y = 100;
	
	CDialog::OnGetMinMaxInfo(lpMMI);
}
