// LookupThread.cpp : implementation file
//

#include "stdafx.h"
#include "hostilechat.h"
#include "LookupThread.h"
#include "PostOffice.h"
#include "HostileChatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLookupThread

IMPLEMENT_DYNCREATE(CLookupThread, CWinThread)

CLookupThread::CLookupThread()
{
	m_hEventKill = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_hEventDead = CreateEvent(NULL, TRUE, FALSE, NULL);

	m_bDeleted = false;
}

CLookupThread::~CLookupThread()
{
	CloseHandle(m_hEventKill);
	CloseHandle(m_hEventDead);
}

BOOL CLookupThread::InitInstance()
{
	CHostileChatApp *pApp = (CHostileChatApp *)AfxGetApp();

	while (!m_bDeleted)
	{
		((CHostileChatDlg*) (pApp->m_pMainWnd))->m_PostOffice.CheckPostStatus();

		if(WaitForSingleObject(m_hEventKill, 100) == WAIT_OBJECT_0)
			break;
	}
	// avoid entering standard message loop by returning FALSE
	return FALSE;
}

int CLookupThread::ExitInstance()
{
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CLookupThread, CWinThread)
	//{{AFX_MSG_MAP(CLookupThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLookupThread message handlers

void CLookupThread::Delete()
{
//	CWinThread::Delete();
	SetEvent(m_hEventDead);
}

void CLookupThread::KillThread()
{
	m_bDeleted = true;
	SetEvent(m_hEventKill);

	// allow thread to run at higher priority during kill process
	SetThreadPriority(THREAD_PRIORITY_ABOVE_NORMAL);
//	WaitForSingleObject(m_hEventDead, INFINITE);
	WaitForSingleObject(m_hThread, INFINITE);

	// now delete CWinThread object since no longer necessary
	delete this;
}
