// Message.h: interface for the CMessage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESSAGE_H__4AA06DA5_AF9A_11D3_9340_004095817FB2__INCLUDED_)
#define AFX_MESSAGE_H__4AA06DA5_AF9A_11D3_9340_004095817FB2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef char MESSAGE_CONTENTS_TYPE[260];
typedef char MESSAGE_POINT_TYPE[50];

struct CMessage  
{
	enum { MID_CHAT, MID_BROADCAST, MID_CONFIRM_PRESENSE, MID_IN_CHATROOM };
	MESSAGE_CONTENTS_TYPE contents;
	MESSAGE_POINT_TYPE creator, addressee;
	UINT id;

	CMessage(void) {;}//: contents("\x0"), creator("\x0"), addressee("\x0"), time("\x0") {;}

	CMessage& operator = (CMessage &from) 
	{
		strcpy(contents, from.contents);
		strcpy(creator, from.creator);
		strcpy(addressee, from.addressee);
		id = from.id;

		return *this;
	}

	void PostMessage(CWnd *pWnd, UINT mID, LPARAM lParm) 
	{
		CMessage *newmsg = new CMessage;
		*newmsg = *this;

		pWnd->PostMessage(mID, (WPARAM) newmsg, lParm);
	}
};

const int ONLINE_UPPER_TIME = 6;
const int ONLINE_LOWER_TIME = 0;

struct CUser
{
	CString name;
///	CString computer;
	int online_counter, inchat_counter;
	bool bOnline, bInchat;

	CUser() : online_counter(ONLINE_LOWER_TIME), inchat_counter(0),
		bOnline(false), bInchat(false) {;}
};

#endif // !defined(AFX_MESSAGE_H__4AA06DA5_AF9A_11D3_9340_004095817FB2__INCLUDED_)
