// MessageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "hostilechat.h"
#include "HostileChatDlg.h"
#include "MessageDlg.h"
#include "Sound.h"
#include "PreferencesSM.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


UINT CMessageDlg::m_uiRef = 0;
CMessageDlg* CMessageDlg::pSelf = NULL;

/////////////////////////////////////////////////////////////////////////////
// CMessageDlg dialog

CMessageDlg::CMessageDlg(CString& szForWhom, CWnd* pParent /*=NULL*/)
	: CDialog(CMessageDlg::IDD, pParent),
	m_btnProperties(IDB_PROPERTIES, IDB_PROPERTIES_MASK, CSize(31,31))

{
	//{{AFX_DATA_INIT(CMessageDlg)
	m_szMessage = _T("");
	//}}AFX_DATA_INIT
	szforWhom = szForWhom;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_MESSAGE);

	m_uiRef++;

	if( m_uiRef == 1 ) 
		pSelf = this; 
}

CMessageDlg::~CMessageDlg()
{
	m_uiRef--;

	if( m_uiRef == 0 )
		pSelf = NULL;
}

void CMessageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMessageDlg)
	DDX_Control(pDX, IDC_PROPERTIES, m_btnProperties);
	DDX_Control(pDX, IDC_MESSAGE, m_editMessage);
	DDX_Text(pDX, IDC_MESSAGE, m_szMessage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMessageDlg, CDialog)
	//{{AFX_MSG_MAP(CMessageDlg)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_EN_CHANGE(IDC_MESSAGE, OnChangeMessage)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_PROPERTIES, OnProperties)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMessageDlg message handlers

//   "Messages"
BOOL CMessageDlg::OnClose() 
{
	CDialog::EndDialog(0);

	return false;
}

int CALLBACK editbreak(LPSTR lpch, int ichCurrent, int cch, int code)
{
	CString sz;

	sz = lpch;
	return 1;
}

//typedef int (CALLBACK* EDITWORDBREAKPROCA)(LPSTR lpch, int ichCurrent, int cch, int code);

BOOL CMessageDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, false);

	SetWindowText("Send message to " + szforWhom);

	//    edit
	((CHostileChatApp*) AfxGetApp())->GetPreferences(&m_pref);
	m_editBrush.CreateSolidBrush(m_pref.rgbBackground);

	SetFont(&m_pref.fontText, true);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMessageDlg::OnChangeMessage() 
{
	CSound::PlayResource(ID_SOUND_TYPE);	
	m_editMessage.SendMessage(EM_SETMARGINS, EC_USEFONTINFO, 0);
}


HBRUSH CMessageDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	if( pWnd->GetSafeHwnd() == m_editMessage.GetSafeHwnd() ) {

		pDC->SelectObject(&m_pref.fontText);
		pDC->SetTextColor(m_pref.rgbText);
		pDC->SetBkColor(m_pref.rgbBackground);

		if(m_pref.bChanged) {
			pWnd->SendMessage(EM_SETMARGINS, EC_USEFONTINFO, 0);
			m_pref.bChanged = false;
		}

		return HBRUSH(m_editBrush);
	}

	if( *pWnd == *this ) {
		pDC->SelectObject(&m_pref.fontText);
	}
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CMessageDlg::OnProperties() 
{
	CPreferencesSM dlg;

	if( dlg.DoModal() == IDOK) {
		((CHostileChatApp*) AfxGetApp())->GetPreferences(&m_pref);

		m_pref.bChanged = true;

		m_editBrush.DeleteObject();	
		m_editBrush.CreateSolidBrush(m_pref.rgbBackground);
		m_editMessage.RedrawWindow();
		m_editMessage.UpdateData(false);
	}
}
