// PictureButton.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "PictureButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPictureButton

CPictureButton::CPictureButton(UINT idBitmap, UINT idMask, CSize &size)
{
//	m_bitmap.LoadBitmap(idBitmap);
//	m_bmpMask.LoadBitmap(idMask);
	m_idBitmap = idBitmap;
	m_idMask = idMask;
	m_bitmapSize = size;
	m_bIsFired = false;
	m_bIsUpdated = false;
	m_what = 0;

	m_bitmap.LoadBitmap(m_idBitmap);
	m_bmpMask.LoadBitmap(m_idMask);
}

CPictureButton::~CPictureButton()
{
}


BEGIN_MESSAGE_MAP(CPictureButton, CButton)
	//{{AFX_MSG_MAP(CPictureButton)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_NCHITTEST()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPictureButton message handlers
void CPictureButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);

	if(lpDrawItemStruct->itemAction == ODA_FOCUS)
	{
		if(lpDrawItemStruct->itemState & ODS_FOCUS)
		{
			m_what = 0;
//			Invalidate();
		}
		else
		{
			m_what = 0;
		}
	}

	if(lpDrawItemStruct->itemAction == ODA_SELECT)
	{
		if(lpDrawItemStruct->itemState & ODS_SELECTED)
		{
			m_what = 1;
		}
		else
		{
			if(lpDrawItemStruct->itemState & ODS_FOCUS)
				m_what = 2;
			else
				m_what = 0;
		}
	}
//	pDC->SetBkColor
//	pDC->PatBlt( 0, 0, m_bitmapSize.cx, m_bitmapSize.cy, PATCOPY);

	pDC->MaskBlt(0, 0, m_bitmapSize.cx, m_bitmapSize.cy, 
		&m_vDC, m_what * m_bitmapSize.cx, 0, m_bmpMask, 
		m_what * m_bitmapSize.cx, 0, MAKEROP4(SRCAND, SRCCOPY));
}

void CPictureButton::Fire(bool bOn)
{
	if( (!m_bIsFired && bOn) || (m_bIsFired && !bOn)) {

		if(bOn) {	// 
			m_what = 2;
			m_bIsFired = true;

			SetCapture();
		}
		else {		// 
			m_what = 0;
			m_bIsFired = false;

			ReleaseCapture();
		}

//		m_vDC.BitBlt(0, 0, m_bitmapSize.cx, m_bitmapSize.cy,
//			&someDC, m_bitmapSize.cx * what, 0, SRCCOPY);
		Invalidate();
	}
}

void CPictureButton::PreSubclassWindow() 
{
	CButton::PreSubclassWindow();

	CDC *pDC = GetDC();

	m_vDC.CreateCompatibleDC(GetDC());
	m_vDC.SelectObject(m_bitmap);

	SetWindowPos( &wndTop, 0, 0, m_bitmapSize.cx, m_bitmapSize.cy,
		SWP_NOMOVE);

	m_tooltip.Create(GetParent(), TTS_ALWAYSTIP);
	CString text; GetWindowText(text);

	m_tooltip.SetDelayTime(200);
	m_tooltip.AddTool(this, text);
}

void CPictureButton::OnMouseMove(UINT nFlags, CPoint point) 
{
//	ClientToScreen(&point);
	CRect rect;
	GetClientRect(rect);

	if(rect.PtInRect(point)) {
		Fire(true);
	}
	else
		Fire(false);
	
	CButton::OnMouseMove(nFlags, point);
}

void CPictureButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//ReleaseCapture();
	//Fire(false);
	m_bIsFired = false;
//	CRect rect;
//	GetClientRect(rect);

//	if(rect.PtInRect(point)) {
//		ReleaseCapture();
//	}

	m_what = 1;
	Invalidate();
	
	CButton::OnLButtonDown(nFlags, point);
}

void CPictureButton::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_what = 2;
	Invalidate();
	
	CButton::OnLButtonUp(nFlags, point);
}

UINT CPictureButton::OnNcHitTest(CPoint point) 
{
	UINT result = CButton::OnNcHitTest(point);
	return result;
}

BOOL CPictureButton::PreTranslateMessage(MSG* pMsg) 
{
	m_tooltip.RelayEvent(pMsg);

	return CButton::PreTranslateMessage(pMsg);
}

void CPictureButton::ResetState()
{
	m_bIsFired = true;
	//Fire(false);
	//RedrawWindow();
}

bool CPictureButton::CanUseMaskFunction()
{
	return false;
}

void CPictureButton::SetPictures(UINT idB, UINT idM)
{
	m_idBitmap = idB;
	m_idMask = idM;
	m_bIsFired = false;
	m_bIsUpdated = false;
	m_what = 0;

	m_bitmap.DeleteObject();
	m_bitmap.LoadBitmap(m_idBitmap);
	m_bmpMask.DeleteObject();
	m_bmpMask.LoadBitmap(m_idMask);

	m_vDC.SelectObject(m_bitmap);

	ResetState();
}

