// Preferences.cpp : implementation file
//

#include "stdafx.h"
#include "hostilechat.h"
#include "Preferences.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPreferences dialog
LPCSTR	lpszText = "Message Text",
		lpszOwner = "User Alias",
		lpszBackground = "Background";


CPreferences::CPreferences(CRuntimeClass *pRuntime)
	: CDialog(CPreferences::IDD, NULL)
{
	//{{AFX_DATA_INIT(CPreferences)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	if( pRuntime == RUNTIME_CLASS(PreferencesChat))
		m_pref = (PreferencesChat *) new PreferencesChat;
	else if (pRuntime == RUNTIME_CLASS(PreferencesInMessage))
		m_pref = (PreferencesInMessage *) new PreferencesInMessage;
}

CPreferences::~CPreferences(void) 
{
	delete m_pref;
}


void CPreferences::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPreferences)
	DDX_Control(pDX, IDC_FONT, m_btnFont);
	DDX_Control(pDX, IDC_COLOR, m_btnColor);
	DDX_Control(pDX, IDC_ITEMS, m_listItems);
	DDX_Control(pDX, IDC_PROTO, m_listProto);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPreferences, CDialog)
	//{{AFX_MSG_MAP(CPreferences)
	ON_BN_CLICKED(IDC_COLOR, OnColor)
	ON_BN_CLICKED(IDC_FONT, OnFont)
	ON_LBN_SELCHANGE(IDC_ITEMS, OnSelchangeItems)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPreferences message handlers

BOOL CPreferences::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_listProto.AddString("Someone%The message about nothing...");
	
	m_listItems.AddString(lpszText);
	m_listItems.AddString(lpszOwner);
	m_listItems.AddString(lpszBackground);
	m_listItems.SetCurSel(0);
	
	((CHostileChatApp *) AfxGetApp())->GetPreferences(m_pref);

	m_listProto.SetFromProperties(m_pref->rgbTitle, m_pref->fontTitle);
	m_listProto.SetWhatProperties(m_pref->rgbText, m_pref->fontText);
	m_listProto.SetBkColor(m_pref->rgbBackground);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPreferences::OnColor() 
{
	CString itemName;
	
	m_listItems.GetText(m_listItems.GetCurSel(), itemName);
	COLORREF *pColor;

	if( itemName == lpszOwner ) {
		pColor = &m_pref->rgbTitle;
	}
	else if(itemName == lpszText) {
		pColor = &m_pref->rgbText;
	}
	else if(itemName == lpszBackground) {
		pColor = &m_pref->rgbBackground;
	}

	CColorDialog dlg(*pColor);
	if(dlg.DoModal() == IDOK) {
		*pColor = dlg.GetColor();

		if( itemName == lpszOwner ) {
			m_listProto.SetFromProperties(m_pref->rgbTitle, m_pref->fontTitle);
		}
		else if(itemName == lpszText) {
			m_listProto.SetWhatProperties(m_pref->rgbText, m_pref->fontText);
		}
		else if(itemName == lpszBackground) {
			m_listProto.SetBkColor(m_pref->rgbBackground);
		}

		m_listProto.RedrawWindow();
		m_listProto.UpdateData(false);
	}
}

void CPreferences::OnFont() 
{
	CString itemName;
	
	m_listItems.GetText(m_listItems.GetCurSel(), itemName);
	CFont *pFont;
	LOGFONT logFont;

	if( itemName == lpszOwner ) {
		pFont = &m_pref->fontTitle;
	}
	else if(itemName == lpszText) {
		pFont = &m_pref->fontText;
	}
	else return;

	pFont->GetLogFont(&logFont);

	CFontDialog dlg(&logFont);
	if(dlg.DoModal() == IDOK) 
	{
		dlg.GetCurrentFont(&logFont);
		pFont->DeleteObject();
		pFont->CreateFontIndirect(&logFont);

		if( itemName == lpszOwner ) {
			m_listProto.SetFromProperties(m_pref->rgbTitle, m_pref->fontTitle);
		}
		else if(itemName == lpszText) {
			m_listProto.SetWhatProperties(m_pref->rgbText, m_pref->fontText);
		}

		m_listProto.RedrawWindow();
		m_listProto.UpdateData(false);
	}
}

void CPreferences::OnOK() 
{
	((CHostileChatApp *) AfxGetApp())->SavePreferences(*m_pref);
	
	CDialog::OnOK();
}

void CPreferences::OnSelchangeItems() 
{
	CString itemName;
	
	m_listItems.GetText(m_listItems.GetCurSel(), itemName);
	if( itemName == lpszOwner ) {
		m_btnColor.EnableWindow(true);
		m_btnFont.EnableWindow(true);
	}
	else if(itemName == lpszText) {
		m_btnColor.EnableWindow(true);
		m_btnFont.EnableWindow(true);
	}
	else if(itemName == lpszBackground) {
		m_btnColor.EnableWindow(true);
		m_btnFont.EnableWindow(false);
	}
}
