// PreferencesSM.cpp : implementation file
//

#include "stdafx.h"
#include "hostilechat.h"
#include "PreferencesSM.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPreferencesSM dialog


CPreferencesSM::CPreferencesSM()
	: CDialog(CPreferencesSM::IDD, NULL)
{
	//{{AFX_DATA_INIT(CPreferencesSM)
	m_szProto = _T("");
	//}}AFX_DATA_INIT
}


void CPreferencesSM::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPreferencesSM)
	DDX_Control(pDX, IDC_PROTO, m_editProto);
	DDX_Text(pDX, IDC_PROTO, m_szProto);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPreferencesSM, CDialog)
	//{{AFX_MSG_MAP(CPreferencesSM)
	ON_BN_CLICKED(IDC_TEXT, OnText)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_BN_CLICKED(IDC_FONTS, OnFonts)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPreferencesSM message handlers

void CPreferencesSM::OnText() 
{
	CColorDialog dlg(m_pref.rgbText);

	if(dlg.DoModal() == IDOK) {
		m_pref.rgbText = dlg.GetColor();

		m_editProto.RedrawWindow();
		m_editProto.UpdateData(false);
	}
}

HBRUSH CPreferencesSM::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	if( pWnd->GetSafeHwnd() == m_editProto.GetSafeHwnd() ) {

		pDC->SelectObject(&m_pref.fontText);
		pDC->SetTextColor(m_pref.rgbText);
		pDC->SetBkColor(m_pref.rgbBackground);

		return HBRUSH(m_brushProto);
	}
		
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CPreferencesSM::OnBack() 
{
	CColorDialog dlg(m_pref.rgbBackground);

	if(dlg.DoModal() == IDOK) {
		m_pref.rgbBackground = dlg.GetColor();

		m_brushProto.DeleteObject();
		m_brushProto.CreateSolidBrush(m_pref.rgbBackground);

		m_editProto.RedrawWindow();
		m_editProto.UpdateData(false);
	}
}

BOOL CPreferencesSM::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	((CHostileChatApp*)AfxGetApp())->GetPreferences(&m_pref);
	m_szProto = "Please, leave me alone !";

	m_brushProto.CreateSolidBrush(m_pref.rgbBackground);

	UpdateData(false);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPreferencesSM::OnFonts() 
{
	LOGFONT logFont;

	m_pref.fontText.GetLogFont(&logFont);

	CFontDialog dlg(&logFont);
	if(dlg.DoModal() == IDOK) 
	{
		dlg.GetCurrentFont(&logFont);
		m_pref.fontText.DeleteObject();
		m_pref.fontText.CreateFontIndirect(&logFont);

		m_editProto.RedrawWindow();
		m_editProto.UpdateData(false);
	}
	
}

void CPreferencesSM::OnOK() 
{
	((CHostileChatApp*)AfxGetApp())->SavePreferences(m_pref);
	
	CDialog::OnOK();
}
